﻿;/////////////////////////////////////////////////////////////////////////////////
;Demo of the OOP class for implementing various kinds of dynamic arrays.

;By Stephen Rodriguez.

;Demonstrates some of the methods exposed by the 'ArrayObject' class.
;/////////////////////////////////////////////////////////////////////////////////

XIncludeFile "arrayClass.pbi"


;Create a array object with room for 11 elements.
  MyArrayObject.ArrayObject
  MyArrayObject = NewArray(10)


If MyArrayObject ;Always check that the object was created successfully.

  Debug "The array object has an upper bound of : " + Str(MyArrayObject\GetUpperBound())

;Write some values to the array.
  For i = 0 To MyArrayObject\GetUpperBound()
    MyArrayObject\SetValue(i, 10*i)  
  Next

;Let us check these values.
  For i = 0 To MyArrayObject\GetUpperBound()
    Debug "Retrieving element " + Str(i) + " -> " + Str(MyArrayObject\GetValue(i))
  Next

;Let us shift the elements left and overwrite the zeroth element.
  MyArrayObject\ShiftElementsLeft(0)
  
;Let us check these values.
  For i = 0 To MyArrayObject\GetUpperBound()
    Debug "Retrieving element " + Str(i) + " (after shift left) -> " + Str(MyArrayObject\GetValue(i))
  Next

;Let us redimension the array.
  MyArrayObject\ReDim(15)

;Let us check these values.
  For i = 0 To MyArrayObject\GetUpperBound()
    Debug "Retrieving element " + Str(i) + " (after re-dimension) -> " + Str(MyArrayObject\GetValue(i))
  Next

;Destroy the array once it is no longer required.
  MyArrayObject\Destroy()

Else
  MessageRequester("Error :", "There was a memory allocation problem creating the array object.")
EndIf
; IDE Options = PureBasic 4.10 Beta 4 (Windows - x86)
; CursorPosition = 50
; FirstLine = 13
; IDE Options = PureBasic 4.40 (Windows - x86)
; CursorPosition = 11
; EnableAsm