﻿;/////////////////////////////////////////////////////////////////////////////////
;An OOP class for implementing dynamic arrays.

;By Stephen Rodriguez.
;January 2010.

;Header file.
;/////////////////////////////////////////////////////////////////////////////////


;/////////////////////////////////////////////////////////////////////////////////
;-Class interfaces.

  ;The following interface contains the base class methods.
    Interface ArrayObject_baseclass
      GetArrayBase.i()
      GetUpperBound.i()
      SwapElements(index1, index2)
    EndInterface

  ;The following interface (inheriting from the base class) contains the additional methods
  ;required to implement a basic array object.
    Interface ArrayObject Extends ArrayObject_baseclass
      Destroy()
      GetValue.i(index)
      SetValue.i(index, Value)
      ShiftElementsLeft(index)
      ShiftElementsRight(index)
      ReDim.i(uBound)
    EndInterface 

  ;The following interface (inheriting from the base class) contains the additional methods
  ;required to implement a structured array object.
    Interface StructuredArrayObject Extends ArrayObject_baseclass
      Destroy()
      GetValue(index, ptrStructure)
      GetPointerToValue.i(index)
      SetValue.i(index, ptrStructure=0)
      ShiftElementsLeft(index)
      ShiftElementsRight(index)
      ReDim.i(uBound)
    EndInterface 
;/////////////////////////////////////////////////////////////////////////////////


; IDE Options = PureBasic 4.40 (Windows - x86)
; CursorPosition = 4